#*************************************************************
# Progamm:			mitteltemperatur_simpel
# Sinn des Programms: 		Berechnung einer globalen Mitteltemperatur
# Sinn der Einheit  :		Ausgabeeinheit	
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		mitteltemperatur_simpel_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			05.02.2020
# Letzte Änderung: 		15.10.2021
#*************************************************************
#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os

#*************************************************************
# Import der Klasse matplotlib.pyplot für die Graphikausgabe
#*************************************************************
import matplotlib.pyplot as plt



class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Rechnerobjekt erzeugt")
    
  
  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")  
 
  #Funktion zum Auflösen der Benutzeroberfläche
  def ende(self):
    self.ausgabe_gui.destroy()
  
  def schirm_ausgabe(self, anfangsdatum, enddatum, anzahl_tage, mitteltemperatur_gesammt, mitteltemperatur_berlin, mitteltemperatur_invercargill, s_gesamt,s_berlin, s_invercargill):
    print("Die Mitteltemperatur über alle Stationen ist:")
    print(round(mitteltemperatur_gesammt,4), " °C")
    print("Die Mitteltemperatur von Berlin ist:")
    print(round(mitteltemperatur_berlin,4), " °C")
    print("Die Mitteltemperatur Invercargill ist:")
    print(round(mitteltemperatur_invercargill,4), " °C")    
    print("unter den Standartabweichungen:")
    print("über alle Stationen:")
    print(round(s_gesamt,4), " K")
    print("über alle Werte aus Berlin:")
    print(round(s_berlin,4), " K")
    print("über alle Werte aus Invercargill:")
    print(round(s_invercargill,4), " K")

    
  def datei_ausgabe(self, ausgabe_datei, anfangsdatum, enddatum, anzahl_tage, mitteltemperatur_gesammt, mitteltemperatur_berlin, mitteltemperatur_invercargill, s_gesamt,s_berlin,\
  s_invercargill):
    fobj_out = open(ausgabe_datei,"w")
    fobj_out.write("Die Mitteltemperatur über alle Stationen ist:\n")
    fobj_out.write(str("%6.4f" %mitteltemperatur_gesammt)) 
    fobj_out.write(" °C\n")
    fobj_out.write("Die Mitteltemperatur von Berlin ist:\n")
    fobj_out.write(str("%6.4f" %mitteltemperatur_berlin)) 
    fobj_out.write(" °C\n")
    fobj_out.write("Die Mitteltemperatur von Invercargill ist:\n")
    fobj_out.write(str("%6.4f" %mitteltemperatur_invercargill)) 
    fobj_out.write(" °C\n")
    fobj_out.write("unter der Standartabweichungen:\n")
    fobj_out.write("über alle Stationen:\n")
    fobj_out.write(str("%6.4f" %s_gesamt)) 
    fobj_out.write(" K\n")
    fobj_out.write("über alle Werte aus Berlin:\n")
    fobj_out.write(str("%6.4f" %s_berlin))
    fobj_out.write(" K\n") 
    fobj_out.write("über alle Werte aus Invercargill:\n")
    fobj_out.write(str("%6.4f" %s_invercargill))
    fobj_out.write(" K\n") 
    fobj_out.write("Die Datenreihe beginnt am:\n")
    fobj_out.write(anfangsdatum)
    fobj_out.write("\n")
    fobj_out.write("und endet am:\n")
    fobj_out.write(enddatum)
    fobj_out.write("\n")
    fobj_out.write("und umfaßt:\n")
    fobj_out.write(str(anzahl_tage))
    fobj_out.write("\n")
    fobj_out.write("Tage.\n")
    fobj_out.close()

  
  def gui_ausgabe(self,anfangsdatum,enddatum,anzahl_tage,mitteltemperatur_gesammt, mitteltemperatur_berlin, mitteltemperatur_invercargill, s_gesamt,s_berlin, s_invercargill):
    import tkinter
    self.ausgabe_gui = tkinter.Tk()
    self.lb_1 = tkinter.Label(self.ausgabe_gui, text = "Globale Mitteltemperatur:")
    self.lb_1.pack()
    self.lb_2 = tkinter.Label(self.ausgabe_gui, text = str(round(mitteltemperatur_gesammt,4))+ " °C") 
    self.lb_2.pack()
    self.lb_3 = tkinter.Label(self.ausgabe_gui, text = "Mitteltemperatur Berlin:")
    self.lb_3.pack()
    self.lb_4 = tkinter.Label(self.ausgabe_gui, text = str(round(mitteltemperatur_berlin,4))+ " °C") 
    self.lb_4.pack()
    self.lb_5 = tkinter.Label(self.ausgabe_gui, text = "Mitteltemperatur Invercargill:")
    self.lb_5.pack()
    self.lb_6 = tkinter.Label(self.ausgabe_gui, text = str(round(mitteltemperatur_invercargill,4))+ " °C") 
    self.lb_6.pack()
    self.lb_7 = tkinter.Label(self.ausgabe_gui, text = "unter den Standartabweichungen:")
    self.lb_7.pack()
    self.lb_8 = tkinter.Label(self.ausgabe_gui, text = "über alle Stationen:")
    self.lb_8.pack()
    self.lb_9 = tkinter.Label(self.ausgabe_gui, text = str(round(s_gesamt,4))+ " K") 
    self.lb_9.pack()
    self.lb_10 = tkinter.Label(self.ausgabe_gui, text = "über alle Werte aus Berlin:")
    self.lb_10.pack()
    self.lb_11 = tkinter.Label(self.ausgabe_gui, text = str(round(s_berlin,4))+ " K") 
    self.lb_11.pack()
    self.lb_12 = tkinter.Label(self.ausgabe_gui, text = "über alle Werte aus Invercargill:")
    self.lb_12.pack()
    self.lb_13 = tkinter.Label(self.ausgabe_gui, text = str(round(s_invercargill,4))+ " K") 
    self.lb_13.pack()
    self.lb_14 = tkinter.Label(self.ausgabe_gui, text = "Für den Zeitraum vom:")
    self.lb_14.pack()
    self.lb_15 = tkinter.Label(self.ausgabe_gui, text = str(anfangsdatum))
    self.lb_15.pack()
    self.lb_16 = tkinter.Label(self.ausgabe_gui, text = "bis zum:")
    self.lb_16.pack()
    self.lb_17 = tkinter.Label(self.ausgabe_gui, text = str(enddatum))
    self.lb_17.pack()
    self.lb_18 = tkinter.Label(self.ausgabe_gui, text = "also über ")
    self.lb_18.pack()
    self.lb_19 = tkinter.Label(self.ausgabe_gui, text = str(anzahl_tage) + " Tage")
    self.lb_19.pack()
    self.bende = tkinter.Button(self.ausgabe_gui, text = "weiter", command = self.ende)
    self.bende.pack()

  #Endlosschleife
    self.ausgabe_gui.mainloop()
    self.rückgabewert = True
    return self.rückgabewert



#*************************************************************
# Funktion zur graphischen Ausgabe: tägliche Mitteltemperatur über alle beiden Stationen
#*************************************************************
  def graphik_ausgabe(self,m, T,graphik_datei_wähler,graphik_datei_name,graphik_datei_format):
   
    delta_x = (float(m-1)-0.0)/10
    x_min=0.0-delta_x
    x_max=float(m-1)+delta_x
    y_min=0.0
    y_max=0.0
    for i in range(m):
      if y_min >= T[i]:
        y_min = T[i]
      if y_max <= T[i]:
        y_max = T[i]
    x = list(range(m))
    plt.plot(T, 'r.')
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/10.0
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title("Tägliche Mitteltemperatur" )
    plt.xlabel("Tag")
    plt.ylabel('Temperatur [°C]')
    
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    if(graphik_datei_wähler):
      try:
        plt.savefig(graphik_datei_name + '.' + graphik_datei_format, format=graphik_datei_format) 
      except:
        print("Graphikdateiformat ",graphik_datei_format ,"wird nicht von python unterstützt") 
        print(" unterstützt werden die Formate:",{'eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'} )
      plt.show()    
      
#*************************************************************
# Funktion zur graphischen Ausgabe: tägliche Mitteltemperatur über alle beiden Stationen 
# und über die einzelnen Stationen
#*************************************************************
  def graphik_ausgabe_stationen(self,m, T,T_berlin, T_invercargill, graphik_datei_wähler,graphik_datei_name,graphik_datei_format):
    delta_x = (float(m-1)-0.0)/10
    x_min=0.0-delta_x
    x_max=float(m-1)+delta_x
    y_min=0.0
    y_max=0.0
    for i in range(m):
      if y_min >= T[i]:
        y_min = T[i]
      if y_max <= T[i]:
        y_max = T[i]
        
    for i in range(m):
      if y_min >= T_berlin[i]:
        y_min = T_berlin[i]
      if y_max <= T_berlin[i]:
        y_max = T_berlin[i]
    
    for i in range(m):
      if y_min >= T_invercargill[i]:
        y_min = T_invercargill[i]
      if y_max <= T_invercargill[i]:
        y_max = T_invercargill[i]        
    x = list(range(m))
    plt.plot(x, T, 'r.', label = 'gemittelt aus beiden Stationen')
    plt.plot(x, T_berlin, 'bx', label = 'Berlin')
    plt.plot(x, T_invercargill, 'g+', label = 'Invercargill')

      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
    y_min-=(y_max-y_min)/10.0
    y_max+=(y_max-y_min)/3.0
    plt.axis([x_min, x_max, y_min, y_max])
    plt.title("Tägliche Mitteltemperatur mit Tagesmittelwerten einzelner Stationen" )
    plt.xlabel("Tag")
    plt.ylabel('Temperatur [°C]')
    plt.legend(loc='upper left')
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    if(graphik_datei_wähler):
      try:
        plt.savefig(graphik_datei_name +  '_stationen.' + graphik_datei_format, format=graphik_datei_format) 
      except:
        print("Graphikdateiformat ",graphik_datei_format ,"wird nicht von python unterstützt") 
        print(" unterstützt werden die Formate:",{'eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'} )
      plt.show()            
      


