#*************************************************************
# Progamm:			mitteltemperatur_simpel
# Sinn des Programms: 		Berechnung einer globalen Mitteltemperatur
# Sinn der Einheit  :		Hauptprogramm	
# Name dieser Datei:		mitteltemperatur_simpel_haupt.py
# Versionsnummer:		1
# Wird aufgerufen von:		-
# Ruft auf:			steuer.py, temp_einlese.py, rechner.py, ausgabe.py
# Nummer im Programmpaket:	1
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			05.02.2020
# Letzte Änderung: 		20.10.2021
#*************************************************************


#*************************************************************
# Importieren der Klassen zur Zeitdokumentation
#*************************************************************

import time
import datetime



from steuer import Steuer
from temp_einlese import Temp_einlese
from rechner import Rechner
from ausgabe import Ausgabe


steuer = Steuer()
temp_einlese=Temp_einlese()
rechner = Rechner()
ausgabe = Ausgabe()

#*************************************************************
# Berechnung der Startzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Startzeit zu einem String "datum_zeit"
#*************************************************************
dt_start = datetime.datetime.now()
lt_start = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_start[0:6]
datum_zeit = "Datum: " +str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)

#*************************************************************
# öffnen der Log-Datei
#*************************************************************
fobj_log = open("mitteltemperatur_simpel.log","w")

#*************************************************************
# Schreiben von Datum und Zeit des Programmstarts 
# in die Logdatei 
#*************************************************************
fobj_log.write("Anfang: "+ "\n" + datum_zeit)
fobj_log.write("\n")

#*************************************************************
# Prüfung, ob Steuerdatei erfolgreich geöffnet wurde
#*************************************************************
if steuer.steuer_input():
  fobj_log.write( "Datei existiert\n")
#*************************************************************
# Prüfung, ob Temperaturdatei erfolgreich geöffnet wurde
#*************************************************************  
  if temp_einlese.temp_input(steuer.eingabedatei):
    fobj_log.write( "Temperatur_Datei existiert\n")
#*************************************************************
# Prüfung, ob die Berechnung durcchgeführt wurde
#*************************************************************    
    if rechner.statistik(temp_einlese.m, temp_einlese.n, temp_einlese.temp_daten):
#*************************************************************
# Ausgabe
#*************************************************************     
      if steuer.schirm_ausgabe_wähler:
        ausgabe.schirm_ausgabe(temp_einlese.anfangsdatum,temp_einlese.enddatum,temp_einlese.anzahl_tage,rechner.mittelwert_gesamt,rechner.mittelwert_berlin,\
        rechner.mittelwert_invercargill,rechner.standartabweichung_gesamt,rechner.standartabweichung_berlin, rechner.standartabweichung_invercargill)
      if steuer.datei_ausgabe_wähler:
        ausgabe.datei_ausgabe(steuer.ausgabe_datei, temp_einlese.anfangsdatum,temp_einlese.enddatum,temp_einlese.anzahl_tage,rechner.mittelwert_gesamt,rechner.mittelwert_berlin,\
        rechner.mittelwert_invercargill,rechner.standartabweichung_gesamt,rechner.standartabweichung_berlin, rechner.standartabweichung_invercargill)

        ausgabe.gui_ausgabe(temp_einlese.anfangsdatum,temp_einlese.enddatum,temp_einlese.anzahl_tage,rechner.mittelwert_gesamt,rechner.mittelwert_berlin,\
        rechner.mittelwert_invercargill,rechner.standartabweichung_gesamt,rechner.standartabweichung_berlin, rechner.standartabweichung_invercargill)
        ausgabe.graphik_ausgabe(temp_einlese.m,rechner.tagesmittel_gesamt,steuer.graphik_datei_ausgabe_wähler,steuer.graphik_datei_name, steuer.graphik_datei_format )
        ausgabe.graphik_ausgabe_stationen(temp_einlese.m,rechner.tagesmittel_gesamt, rechner.tagesmittel_berlin ,\
        rechner.tagesmittel_invercargill,steuer.graphik_datei_ausgabe_wähler,steuer.graphik_datei_name, steuer.graphik_datei_format )
    else:
      fobj_log.write( "Fehler in der Rechnung\n")
  else:
    fobj_log.write( "Temperatur_Datei existiert nicht\n")
else:
  fobj_log.write( "Steuerdatei existiert nicht\n")












#*************************************************************
# Berechnung der Endzeit des Programmes mit:
# a) datetime
# b) time
# und Konvertieren der Endzeit zu einem String "datum_zeit"
#*************************************************************
lt_end = time.localtime()
jahr, monat, tag, stunde, minute, sekunde  = lt_end[0:6]
datum_zeit = "Datum: "+str(tag)+"."+str(monat)+"."+str(jahr)+"\n"+"Zeit: "+str(stunde)+":"+str(minute)+":"+str(sekunde)
dt_end = datetime.datetime.now()

#*************************************************************
# Berechnung der Rechendauer mit dem Zeitdifferenzoperator 
# des Moduls datetime
#*************************************************************
dauer = dt_end - dt_start

#*************************************************************
# Schreiben von Datum und Zeit des Programmendes und der 
# Rechendauer in die Logdatei 
#*************************************************************
fobj_log.write("Ende: "+ "\n" +datum_zeit + "\n")
fobj_log.write("Rechendauer: "+ "\n" + str(dauer))

#*************************************************************
# Schließen der Logdatei
#*************************************************************
fobj_log.close()

#*************************************************************
#Programmende
#*************************************************************




