#*************************************************************
# Progamm:			mitteltemperatur_simpel
# Sinn des Programms: 		Berechnung einer globalen Mitteltemperatur
# Sinn der Einheit  :		Berechnung einer globalen Mitteltemperatur
# Name dieser Datei:		rechner.py
# Versionsnummer:		1
# Wird aufgerufen von:		mitteltemperatur_simpel_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			05.02.2020
# Letzte Änderung: 		01.10.2021
#*************************************************************
import math
import numpy as np


class Rechner:
  #Konstruktormethode
  def __init__(self):		
    print("Rechnerobjekt erzeugt")
    
  
  #Destruktormethode
  def __del__(self):	
    print("Rechnerobjekt entfernt")  


  def statistik(self, m, n, temperatur):
    print("Statistikfunktion")
    try:
      self.mittelwert_gesamt = self.mittelwert(m,0,n,temperatur)
      self.mittelwert_berlin = self.mittelwert(m,0,8,temperatur) 
      self.mittelwert_invercargill = self.mittelwert(m,8,n,temperatur)
    
      self.standartabweichung_gesamt = self.standartabweichung(m,0,n,temperatur,self.mittelwert_gesamt)
      self.standartabweichung_berlin = self.standartabweichung(m,0,8,temperatur,self.mittelwert_berlin)
      self.standartabweichung_invercargill = self.standartabweichung(m,8,n,temperatur,self.mittelwert_invercargill)
    
      self.tagesmittel_gesamt = self.tagesmittel(m,0,n,temperatur)
      self.tagesmittel_berlin = self.tagesmittel(m,0,8,temperatur)
      self.tagesmittel_invercargill = self.tagesmittel(m,8,n,temperatur)
      return True
    except:
      return False  

  def mittelwert(self,m,n_anf,n_end,T):
    print("Mittelwert")
    summe = 0.0
    for i in range(m):
      for j in range(n_anf,n_end):
        summe += T[i][j]
    mittelwert = summe / ((n_end - n_anf) * (m) )
    return mittelwert
    
  def standartabweichung(self,m,n_anf,n_end,T,mittelwert):
    print("Standartabweichung")
    summe = 0.0
    for i in range(m):
      for j in range(n_anf,n_end):
        summe += (T[i][j] - mittelwert)**2
    summe /= (((n_end - n_anf) * (m) ) - 1)
    standartabweichung = math.sqrt(summe)     
    return standartabweichung
#*************************************************************
# Funktion für Tagesmittelwerte für Graphiken
#************************************************************* 
  def tagesmittel(self,m,n_anf,n_end,T):
    print("Tagesmittel")
    T_tagesmittel = np.zeros(m)
    for i in range(m):
      summe = 0.0
      for j in range(n_anf,n_end):
        summe += T[i][j]
      T_tagesmittel[i] = summe/(n_end-n_anf)  
    return T_tagesmittel
